%Coupled and uncoupled (so far)

clear all
close all
lambda=15; % Scaling factor
ro=1.025; % Density of water

filename=[...
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1100a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3100a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4100a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5100a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6100a.bin';
];

% Wave periods
T=[1.291; 1.291; 1.291; 1.291; 1.291; 1.291;
    ];
% Wave probe to origo distance
wp=[3.775; 3.775; 0.085; 0.085; 0.7525; 3.775;
    ];
for i=1:size(filename,1)
clc
clearvars -except filename i T wp lambda ro first last RAOstruct Wave_specs
disp(' ') 
disp('Filename: ')
disp(filename(i,:))
disp(' ')

% Read results from file
[a1,a2,Time,Frame,Fx_58,Fy_58,Fz_58,Fx_96,Fy_96,Fz_96,Xpos,Ypos,Zpos,Roll,Pitch,Yaw,Wave]=catman_read(filename(i,:));

%% Correcting for shift b/c of wave probe placement:
g=9.81; %Gravity
omega=2*pi/T(i);
V_p=g/omega; %Phase velocity
time_lag=wp(i)/V_p; %Time for wave to travel between wave probe and origo
fz=200; %Sample frequency wave probe
frame_lag=round(time_lag*fz);

% Shift wave 
for j=(frame_lag+1):(length(Wave)-frame_lag-1)
    Wave2(j)=Wave(j-frame_lag); 
end

Wave=Wave2; % Replacing unshifted wave with shifted wave. 

%% Scaling

Time=Time*sqrt(lambda);
Fx_58=ro*lambda^3*Fx_58;
Fy_58=ro*lambda^3*Fy_58;
Fz_58=ro*lambda^3*Fz_58;
Fx_96=ro*lambda^3*Fx_96;
Fy_96=ro*lambda^3*Fy_96;
Fz_96=ro*lambda^3*Fz_96;
Xpos=lambda*Xpos;
Ypos=lambda*Ypos;
Zpos=lambda*Zpos;
Wave=lambda*Wave;

fig = figure;
set(fig,'units','normalized','outerposition',[0.5 0 0.5 1]);

% Plot for visual inspection
subplot(6,2,1); plot(Time, Xpos); title('Xpos')
subplot(6,2,2); plot(Time, Ypos); title('Ypos')
subplot(6,2,3); plot(Time, Zpos); title('Zpos')
subplot(6,2,4); plot(Time, Roll); title('Roll')
subplot(6,2,5); plot(Time, Pitch); title('Pitch')
subplot(6,2,6); plot(Time, Yaw); title('Yaw')
subplot(6,2,7); plot(Time,Fx_58); title('Fx_58')
subplot(6,2,8); plot(Time,Fy_58); title('Fy_58')
subplot(6,2,9); plot(Time,Fz_58); title('Fz_58')
subplot(6,2,10); plot(Time,Fx_96); title('Fx_96')
subplot(6,2,11); plot(Time,Fy_96); title('Fy_96')
subplot(6,2,12); plot(Time,Fz_96); title('Fz_96')

%% Extracting best time periods 
%Find scaled sampling frequency
fi=Time(3)-Time(2);
fc=1/fi;

finish=0;
while finish==0
 
disp('Enter start and end time, enter 0 for both for reset')
disp(length(Time)/fc)
first(i)=round(fc*input('Enter start time: ')); 
last(i)=round(fc*input('Enter end time: '));   


if first(i)==0; first(i)=1; end
if last(i)==0; last(i)=length(Time); end

%Extracting desired time periods   
Wave_red=Wave(1,first(i):last(i));
Time_red=Time(1,first(i):last(i));
Xpos_red=Xpos(1,first(i):last(i));
Ypos_red=Ypos(1,first(i):last(i));
Zpos_red=Zpos(1,first(i):last(i));
Roll_red=Roll(1,first(i):last(i));
Pitch_red=Pitch(1,first(i):last(i));
Yaw_red=Yaw(1,first(i):last(i));
Fx_58_red=Fx_58(1,first(i):last(i));
Fy_58_red=Fy_58(1,first(i):last(i));
Fz_58_red=Fz_58(1,first(i):last(i));
Fx_96_red=Fx_96(1,first(i):last(i));
Fy_96_red=Fy_96(1,first(i):last(i));
Fz_96_red=Fz_96(1,first(i):last(i));

%New plots
subplot(6,2,1); plot(Time_red, Xpos_red); title('Xpos')
subplot(6,2,2); plot(Time_red, Ypos_red); title('Ypos')
subplot(6,2,3); plot(Time_red, Zpos_red); title('Zpos')
subplot(6,2,4); plot(Time_red, Roll_red); title('Roll')
subplot(6,2,5); plot(Time_red, Pitch_red); title('Pitch')
subplot(6,2,6); plot(Time_red, Yaw_red); title('Yaw')
subplot(6,2,7); plot(Time_red,Fx_58_red); title('Fx_58')
subplot(6,2,8); plot(Time_red,Fy_58_red); title('Fy_58')
subplot(6,2,9); plot(Time_red,Fz_58_red); title('Fz_58')
subplot(6,2,10); plot(Time_red,Fx_96_red); title('Fx_96')
subplot(6,2,11); plot(Time_red,Fy_96_red); title('Fy_96')
subplot(6,2,12); plot(Time_red,Fz_96_red); title('Fz_96')

finish=input('All good? yes=1, no=0 ');
end
close all

%% Remove bias
Xpos=Xpos-(mean(Xpos_red));
Ypos=Ypos-(mean(Ypos_red));
Zpos=Zpos-(mean(Zpos_red));
Yaw=Yaw-(mean(Yaw_red));
Roll=Roll-mean(Roll_red);
Pitch=Pitch-mean(Pitch_red);
Fx_58=Fx_58-mean(Fx_58_red);
Fy_58=Fy_58-mean(Fy_58_red);
Fz_58=Fz_58-mean(Fz_58_red);
Fx_96=Fx_96-mean(Fx_96_red);
Fy_96=Fy_96-mean(Fy_96_red);
Fz_96=Fz_96-mean(Fz_96_red);


%% Remove spikes 

% Create limits for accepting or rejecting value
lim(1)=max(Xpos_red)-mean(Xpos_red);
lim(2)=max(Ypos_red)-mean(Ypos_red);
lim(3)=max(Zpos_red)-mean(Zpos_red);
lim(4)=max(Roll_red)-mean(Roll_red);
lim(5)=max(Pitch_red)-mean(Pitch_red);
lim(6)=max(Yaw_red)-mean(Yaw_red);
lim(7)=max(Fx_58_red)-mean(Fx_58_red);
lim(8)=max(Fy_58_red)-mean(Fy_58_red);
lim(9)=max(Fz_58_red)-mean(Fz_58_red);
lim(10)=max(Fx_96_red)-mean(Fx_96_red);
lim(11)=max(Fy_96_red)-mean(Fy_96_red);
lim(12)=max(Fz_96_red)-mean(Fz_96_red);


% Create new arrays for new and old time series, discard 50 first frames
Uncorrected(1,:)=Xpos(50:end);
Uncorrected(2,:)=Ypos(50:end);
Uncorrected(3,:)=Zpos(50:end);
Uncorrected(4,:)=Roll(50:end);
Uncorrected(5,:)=Pitch(50:end);
Uncorrected(6,:)=Yaw(50:end);
Uncorrected(7,:)=Fx_58(50:end);
Uncorrected(8,:)=Fy_58(50:end);
Uncorrected(9,:)=Fz_58(50:end);
Uncorrected(10,:)=Fx_96(50:end);
Uncorrected(11,:)=Fy_96(50:end);
Uncorrected(12,:)=Fz_96(50:end);

Corrected(1,:)=Xpos(50:end);
Corrected(2,:)=Ypos(50:end);
Corrected(3,:)=Zpos(50:end);
Corrected(4,:)=Roll(50:end);
Corrected(5,:)=Pitch(50:end);
Corrected(6,:)=Yaw(50:end);
Corrected(7,:)=Fx_58(50:end);
Corrected(8,:)=Fy_58(50:end);
Corrected(9,:)=Fz_58(50:end);
Corrected(10,:)=Fx_96(50:end);
Corrected(11,:)=Fy_96(50:end);
Corrected(12,:)=Fz_96(50:end);
Time=Time(50:end);


% Remove spikes larger than 2*limit value, replace with spline interpolated
% values
for sp=1:12;
   
tmp=Uncorrected(sp,:);
spike = false;
correction = false;
   
    
for l=1:length(Uncorrected(1,:))
    %Store 3 values prior to spike
    if abs(tmp(l))>2*(lim(sp)) && spike==false;

        t1=l-1;
        j=l;
        y(3)=tmp(j-1);
        x(3)=j-1;
        while y(3) == tmp(j-1); j=j-1; end
        y(2)=tmp(j-1); 
        x(2)=j-1;
        while y(2) == tmp(j-1); j=j-1; end
        y(1)=tmp(j-1) ;
        x(1)=j-1;
        spike=true;
     %Store 3 values after spike
    elseif abs(tmp(l))<2*lim(sp) && spike==true;
       
        t2=l;
        j=l;
        
        y(4) = tmp(j);	x(4) = j;
		while y(4) == tmp(j)
			j = j+1;
		end;
		y(5) = tmp(j);	x(5) = j;
		while y(5) == tmp(j)
			j = j+1;
		end;
		y(6) = tmp(j);	x(6) = j;
		
		spike = false;
		correction = true;
    end    
    	if correction == true;
		F = griddedInterpolant(x,y,'spline');
		xq = t1:1:t2;
		Corrected(sp,t1:t2) = F(xq);
		correction = false;
	end;    
        
end
end

% Plot with and without spikes
pl=7;
figure
plot(Time, Uncorrected(pl,:),'r')
hold on
plot(Time,Corrected(pl,:),'b','linewidth',1)
legend('Before spike removal','After spike removal')
xlabel('Time(s)')
ylabel('X-postion (m)')


% Return to original time series names, for simplicity

minlen=min(length(Wave),length(Corrected(1,:)));
Wave=Wave(1:minlen);
Xpos=Corrected(1,1:minlen);
Ypos=Corrected(2,1:minlen);
Zpos=Corrected(3,1:minlen);
Roll=Corrected(4,1:minlen);
Pitch=Corrected(5,1:minlen);
Yaw=Corrected(6,1:minlen);
Fx_58=Corrected(7,1:minlen);
Fy_58=Corrected(8,1:minlen);
Fz_58=Corrected(9,1:minlen);
Fx_96=Corrected(10,1:minlen);
Fy_96=Corrected(11,1:minlen);
Fz_96=Corrected(12,1:minlen);
Time=Time(1:minlen);

%New plots
subplot(6,2,1); plot(Time, Xpos); title('Xpos')
subplot(6,2,2); plot(Time, Ypos); title('Ypos')
subplot(6,2,3); plot(Time, Zpos); title('Zpos')
subplot(6,2,4); plot(Time, Roll); title('Roll')
subplot(6,2,5); plot(Time, Pitch); title('Pitch')
subplot(6,2,6); plot(Time, Yaw); title('Yaw')
subplot(6,2,7); plot(Time,Fx_58); title('Fx_58')
subplot(6,2,8); plot(Time,Fy_58); title('Fy_58')
subplot(6,2,9); plot(Time,Fz_58); title('Fz_58')
subplot(6,2,10); plot(Time,Fx_96); title('Fx_96')
subplot(6,2,11); plot(Time,Fy_96); title('Fy_96')
subplot(6,2,12); plot(Time,Fz_96); title('Fz_96')


%% Filter results

%Calculating FFT of unfiltered
N=size(Wave_red,2)/2;
Wave_mag=abs(fft(Wave_red));
Fx_58_mag=abs(fft(Fx_58_red));
Fy_58_mag=abs(fft(Fy_58_red));
Fz_58_mag=abs(fft(Fz_58_red));
Fx_96_mag=abs(fft(Fx_96_red));
Fy_96_mag=abs(fft(Fy_96_red));
Fz_96_mag=abs(fft(Fz_96_red));
Xpos_mag=abs(fft(Xpos_red));
Ypos_mag=abs(fft(Ypos_red));
Zpos_mag=abs(fft(Zpos_red));
Roll_mag=abs(fft(Roll_red));
Pitch_mag=abs(fft(Pitch_red));
Yaw_mag=abs(fft(Yaw_red));


%Frequencies
num=length(Wave_red);
fs=fc; 
f=[0:1/(num/2-1):1]*fs/2; %Frequencies from 0 to 1 

%Design a band-pass Butterworth filter
Wn1=0.4/(T(i)*sqrt(lambda));
Wn2=5/(T(i)*sqrt(lambda)); 

Wp = [Wn1 Wn2]*2/fc; 
Ws = [Wn1*0.5 Wn2*1.5]*2/fc; 
Rp = 3; 
Rs = 4;
[n,Wn] = buttord(Wp,Ws,Rp,Rs);  % Gives mimimum order of filter   
[b3,a3] = butter(n,Wn);         % Design the filter   
    
hv=fvtool(b3,a3); %Plot filter properties

% Apply filter
Wavefil=filtfilt(b3,a3,Wave_red);
Fx_58fil=filtfilt(b3,a3,Fx_58_red);
Fy_58fil=filtfilt(b3,a3,Fy_58_red);
Fz_58fil=filtfilt(b3,a3,Fz_58_red);
Fx_96fil=filtfilt(b3,a3,Fx_96_red);
Fy_96fil=filtfilt(b3,a3,Fy_96_red);
Fz_96fil=filtfilt(b3,a3,Fz_96_red);
Xposfil=filtfilt(b3,a3,Xpos_red);
Yposfil=filtfilt(b3,a3,Ypos_red);
Zposfil=filtfilt(b3,a3,Zpos_red);
Rollfil=filtfilt(b3,a3,Roll_red);
Pitchfil=filtfilt(b3,a3,Pitch_red);
Yawfil=filtfilt(b3,a3,Yaw_red);

%Calculate and plot the response magnitude
Wavefil_mag=abs(fft(Wavefil));
Fx_58fil_mag=abs(fft(Fx_58fil));
Fy_58fil_mag=abs(fft(Fy_58fil));
Fz_58fil_mag=abs(fft(Fz_58fil));
Fx_96fil_mag=abs(fft(Fx_96fil));
Fy_96fil_mag=abs(fft(Fy_96fil));
Fz_96fil_mag=abs(fft(Fz_96fil));
Xposfil_mag=abs(fft(Xposfil));
Yposfil_mag=abs(fft(Yposfil));
Zposfil_mag=abs(fft(Zposfil));
Rollfil_mag=abs(fft(Rollfil));
Pitchfil_mag=abs(fft(Pitchfil));
Yawfil_mag=abs(fft(Yawfil));

% Save wavespectrum plot to file
ymax=(max(smooth(Wave_mag(1:length(f))))*1.3); 
h=figure;
plot(f,smooth(Wave_mag(1:length(f))))
hold on
plot(f,smooth(Wavefil_mag(1:length(f))),'r')
legend('Unfiltered','Band-pass filtered')
xlabel('Frequency (Hz)')
ylabel('Magnitude')
axis([0 1 0 ymax])

name = sprintf('Results/%s_wave_filtering', filename(i,47:51));
print(h,'-djpeg',name);
close all
disp('Plot saved to file.')
disp(name)
disp(' ')



%% Spectra and transfer functions 

m=length(f);

%Create a matrix with time series for plotting
Time_series_red(1,:)=Xpos(5000:10000); %Channel 1 = Surge
Time_series_red(2,:)=Ypos(5000:10000); %Channel 2 = Sway
Time_series_red(3,:)=Zpos(5000:10000); %Channel 3 = Heave
Time_series_red(4,:)=Roll(5000:10000); %Channel 4 = Roll
Time_series_red(5,:)=Pitch(5000:10000); %Channel 5 = Pitch
Time_series_red(6,:)=Yaw(5000:10000);  %Channel 6 = Yaw
Time_series_red(7,:)=Fx_58(5000:10000); %Channel 7 = Fx_58
Time_series_red(8,:)=Fy_58(5000:10000); %Channel 8 = Fy_58
Time_series_red(9,:)=Fz_58(5000:10000); %Channel 9 = Fz_58
Time_series_red(10,:)=Fx_96(5000:10000); %Channel 10 = Fx_96
Time_series_red(11,:)=Fy_96(5000:10000); %Channel 11 = Fy_96
Time_series_red(12,:)=Fz_96(5000:10000); %Channel 12 = Fz_96

%Determine relative phases:
angle_wave=180*(angle(fft(Wavefil(1:m))))/pi'; %find angle, convert to degrees
angles(1,:)=180*(angle(fft(Xposfil(1:m))))/pi;
angles(2,:)=180*(angle(fft(Yposfil(1:m))))/pi;
angles(3,:)=180*(angle(fft(Zposfil(1:m))))/pi;
angles(4,:)=180*(angle(fft(Rollfil(1:m))))/pi;
angles(5,:)=180*(angle(fft(Pitchfil(1:m))))/pi;
angles(6,:)=180*(angle(fft(Yawfil(1:m))))/pi;
angles(7,:)=180*(angle(fft(Fx_58fil(1:m))))/pi;
angles(8,:)=180*(angle(fft(Fy_58fil(1:m))))/pi;
angles(9,:)=180*(angle(fft(Fz_58fil(1:m))))/pi;
angles(10,:)=180*(angle(fft(Fx_96fil(1:m))))/pi;
angles(11,:)=180*(angle(fft(Fy_96fil(1:m))))/pi;
angles(12,:)=180*(angle(fft(Fz_96fil(1:m))))/pi;


for p=1:12
    rel_ang(p,:)=(angles(p,:)./angle_wave);
end


% Find wave spectrum by pwelch:
[Wave_spec,fw]=pwelch(Wavefil, [],[],[],fc);
Wave_specs(:,i)=Wave_spec;
Wave_freqs(:,i)=fw;

% Find response spectra by pwelch:
[Response_spec(1,:),fr]=pwelch(Xposfil, [],[],[],fc);
[Response_spec(2,:),fr]=pwelch(Yposfil, [],[],[],fc);
[Response_spec(3,:),fr]=pwelch(Zposfil, [],[],[],fc);
[Response_spec(4,:),fr]=pwelch(Rollfil, [],[],[],fc);
[Response_spec(5,:),fr]=pwelch(Pitchfil, [],[],[],fc);
[Response_spec(6,:),fr]=pwelch(Yawfil, [],[],[],fc);
[Response_spec(7,:),fr]=pwelch(Fx_58fil, [],[],[],fc);
[Response_spec(8,:),fr]=pwelch(Fy_58fil, [],[],[],fc);
[Response_spec(9,:),fr]=pwelch(Fz_58fil, [],[],[],fc);
[Response_spec(10,:),fr]=pwelch(Fx_96fil, [],[],[],fc);
[Response_spec(11,:),fr]=pwelch(Fy_96fil, [],[],[],fc);
[Response_spec(12,:),fr]=pwelch(Fz_96fil, [],[],[],fc);


% Find RAO
RAO(1,:)=sqrt(Response_spec(1,:)./Wave_spec');
RAO(2,:)=sqrt(Response_spec(2,:)./Wave_spec');
RAO(3,:)=sqrt(Response_spec(3,:)./Wave_spec');
RAO(4,:)=sqrt(Response_spec(4,:)./Wave_spec');
RAO(5,:)=sqrt(Response_spec(5,:)./Wave_spec');
RAO(6,:)=sqrt(Response_spec(6,:)./Wave_spec');
RAO(7,:)=sqrt(Response_spec(7,:)./Wave_spec');
RAO(8,:)=sqrt(Response_spec(8,:)./Wave_spec');
RAO(9,:)=sqrt(Response_spec(9,:)./Wave_spec');
RAO(10,:)=sqrt(Response_spec(10,:)./Wave_spec');
RAO(11,:)=sqrt(Response_spec(11,:)./Wave_spec');
RAO(12,:)=sqrt(Response_spec(12,:)./Wave_spec');

%Save RAO to struct for later plotting
RAOstruct(i)=struct('Surge',RAO(1,:),...
                'Sway',RAO(2,:),...
'Heave',RAO(3,:),...
'Roll',RAO(4,:),...
'Pitch',RAO(5,:),...
'Yaw',RAO(6,:),...
'Fx_58',RAO(7,:),...
'Fy_58',RAO(8,:),...
'Fz_58',RAO(9,:),...
'Fx_96',RAO(10,:),...
'Fy_96',RAO(11,:),...
'Fz_96',RAO(12,:)...
            );
        
%Determine coherence:
coh(1,:)=smooth(mscohere(Wave_red,Xpos_red));
coh(2,:)=smooth(mscohere(Wave_red,Ypos_red));
coh(3,:)=smooth(mscohere(Wave_red,Zpos_red));
coh(4,:)=smooth(mscohere(Wave_red,Roll_red));
coh(5,:)=smooth(mscohere(Wave_red,Pitch_red));
coh(6,:)=smooth(mscohere(Wave_red,Yaw_red));
coh(7,:)=smooth(mscohere(Wave_red,Fx_58_red));
coh(8,:)=smooth(mscohere(Wave_red,Fy_58_red));
coh(9,:)=smooth(mscohere(Wave_red,Fz_58_red));
coh(10,:)=smooth(mscohere(Wave_red,Fx_96_red));
coh(11,:)=smooth(mscohere(Wave_red,Fy_96_red));
coh(12,:)=smooth(mscohere(Wave_red,Fz_96_red));


%% Preparing to plot

% Adjusting frequency range according to coh
f_coh=f(1:length(coh));

% Create array of y-labels
y_label{1}='X-position (m)';
y_label{2}='Y-position (m)';
y_label{3}='Z-position (m)';
y_label{4}='Roll angle (deg)';
y_label{5}='Pitch angle (deg)';
y_label{6}='Yaw angle (deg)';
y_label{7}='Fx-58 (N)';
y_label{8}='Fy-58 (N)';
y_label{9}='Fz-58 (N)';
y_label{10}='Fx-96 (N)';
y_label{11}='Fy-96 (N)';
y_label{12}='Fz-96 (N)';

% Time vector, plot limits
timered=length(Time_series_red);
fmax=ceil((1/(f(3)-f(2))));
sl=length(Response_spec(1,:));

%% Plotting spectral analysis results

for k=1:size(coh,1) %k runs through the different channels. 

hh=figure;
set(hh,'units','normalized','outerposition',[0.4 0.4 0.38 0.58]);

xmax=find(fr>0.3);
xmax=xmax(1);


if k<=3 % Unit:  m/m 
   
subplot(3,2,1);     plot(Time_red(1:timered),Time_series_red(k,:));         title('Time series');       xlabel('Time (s)');         ylabel(y_label{k});        xlim([Time_red(1) (Time_red(1)+90)]) 
subplot(3,2,2);     plot(fw,smooth(Wave_spec));                             title('Wave spectrum');     xlabel('Frequency (Hz)');   ylabel('S(f) (m^2s) ');           axis([0 0.6 0 max(Wave_spec)*1.1]);
subplot(3,2,4);     plot(fr,smooth(RAO(k,:)));                              title('RAO');               xlabel('Frequency (Hz)');   ylabel('RAO (m/m)');             axis([0 0.6 0 max(RAO(k,1:xmax))*1.1]);
subplot(3,2,3);     plot(fr,smooth(Response_spec(k,:)));                    title('Response spectrum'); xlabel('Frequency (Hz)');   ylabel('S(f) (m^2s)');            axis([0 0.6 0 max(Response_spec(k,:))]);
subplot(3,2,5);     plot(f(1:length(rel_ang(k,:))),smooth(rel_ang(k,:)));   title('Relative phase');    xlabel('Frequency (Hz)');   ylabel('Rel. phase');           axis([0 0.6 -50 50 ]);
subplot(3,2,6);     plot(f_coh,smooth(coh(k,:)));                           title('Coherence');         xlabel('Frequency (Hz)');   ylabel(' ');                    axis([0 0.6 min(coh(k,(1:fmax)))*1.3 max(coh(k,(1:fmax)))*1.3]);

%Save plot to file. 
name = sprintf('Results/%s_Spectral_analysis_Channel_%i', filename(i,47:51),k);
print(hh,'-djpeg',name);
% close all
disp('Plot saved to file:')
disp(name)
disp(' ')

elseif k>3 && k<=6 % Unit: deg/m 
subplot(3,2,1);     plot(Time_red(1:timered),Time_series_red(k,:));          title('Time series');       xlabel('Time (s)');         ylabel(y_label{k});             xlim([Time_red(1) (Time_red(1)+90)]) 
subplot(3,2,2);     plot(fw,smooth(Wave_spec));                              title('Wave spectrum');     xlabel('Frequency (Hz)');   ylabel('S(f) (deg^2s) ');       axis([0 0.6 0 max(Wave_spec)*1.1]);
subplot(3,2,4);     plot(fr,smooth(RAO(k,:)));                               title('RAO');               xlabel('Frequency (Hz)');   ylabel('RAO (deg/m)');          axis([0 0.6 0 max(RAO(k,1:xmax))*1.1]);
subplot(3,2,3);     plot(fr,smooth(Response_spec(k,:)));                     title('Response spectrum'); xlabel('Frequency (Hz)');   ylabel('S(f) (deg^2s)');        axis([0 0.6 0 max(Response_spec(k,:))]);
subplot(3,2,5);     plot(f(1:length(rel_ang(k,:))),smooth(rel_ang(k,:)));    title('Relative phase');    xlabel('Frequency (Hz)');   ylabel('Rel. phase');          axis([0 0.6 -50 50 ]);
subplot(3,2,6);     plot(f_coh,smooth(coh(k,:)));                            title('Coherence');         xlabel('Frequency (Hz)');   ylabel(' ');                    axis([0 0.6 min(coh(k,(1:fmax)))*1.3 max(coh(k,(1:fmax)))*1.3]);

%Save plot to file. 
name = sprintf('Results/%s_Spectral_analysis_Channel_%i', filename(i,47:51),k);
print(hh,'-djpeg',name);
% close all
disp('Plot saved to file:')
disp(name)
disp(' ')

elseif k>6 % Unit: N/m
subplot(3,2,1);     plot(Time_red(1:timered),Time_series_red(k,:));         title('Time series');       xlabel('Time (s)');         ylabel(y_label{k});                 xlim([Time_red(1) (Time_red(1)+90)]) 
subplot(3,2,2);     plot(fw,smooth(Wave_spec));                             title('Wave spectrum');     xlabel('Frequency (Hz)');   ylabel('S(f) (N^2s) ');           axis([0 0.6 0 max(Wave_spec)*1.1]);
subplot(3,2,4);     plot(fr,smooth(RAO(k,:)));                              title('RAO');               xlabel('Frequency (Hz)');   ylabel('RAO (N/m)');             xlim([0 0.6]) % 0 max(RAO(k,1:xmax))*1.1]);
subplot(3,2,3);     plot(fr,smooth(Response_spec(k,:)));                    title('Response spectrum'); xlabel('Frequency (Hz)');   ylabel('S(f) (N^2s)');            xlim([0 0.6]) % 0 max(Response_spec(k,1:round(0.6*xmax)))]);
subplot(3,2,5);     plot(f(1:length(rel_ang(k,:))),smooth(rel_ang(k,:)));   title('Relative phase');    xlabel('Frequency (Hz)');   ylabel('Rel. phase');               axis([0 0.6 -50 50 ]);
subplot(3,2,6);     plot(f_coh,smooth(coh(k,:)));                           title('Coherence');         xlabel('Frequency (Hz)');   ylabel(' ');                         axis([0 0.6 min(coh(k,(1:fmax)))*1.3 max(coh(k,(1:fmax)))*1.3]);


%Save plot to file. 
name = sprintf('Results/%s_Spectral_analysis_Channel_%i', filename(i,47:51),k);
print(hh,'-djpeg',name);
% close all
disp('Plot saved to file:')
disp(name)
disp(' ')
end

%% Spectral moments, statistics

% Aquire moments
S=Response_spec(k,:)';
dfr=fr(2)-fr(1);
S=S(1:length(fr));

m0=sum(S.*dfr);
m1=sum(fr.*S.*dfr);
m2=sum((fr.^2).*S.*dfr);


%Peak period of response:
[maks ind]=max(Response_spec(k,:));
Tp=1/(f(ind));
Stdev=sqrt(m0);
Sigval=4*sqrt(m0);
T1=m0/m1; %Average period of response
T2=sqrt(m0/m2); %Average zero-crossing period

%Statistics
Mean=mean(Time_series_red(k,:));
Max=max(Time_series_red(k,:));
Min=min(Time_series_red(k,:));
Stdev=std(Time_series_red(k,:));
nummax=3*3600/Tp;


% Rayleigh distribution
[amp locs2]=findpeaks(Corrected(k,:),'minpeakheight',0); % Find all peaks larger than zero

%Expected value of the largest max according to Rayleigh 
exp_max=Stdev*(sqrt(2*log(nummax)+0.5772/sqrt(2*log(nummax))))

%Most probably largest max according to Rayleigh:
prob_max=Stdev*sqrt(2*log(nummax))


%Save spectral analysis results to file
name = sprintf('Results/%s_spectral_analysis_Channel_%i.txt', filename(i,47:51),k);
fid3=fopen(name,'w');

fprintf(fid3,'%f\n',m0);
fprintf(fid3,'%f\n',m1);
fprintf(fid3,'%f\n',m2);
fprintf(fid3,'%f\n',Sigval);
fprintf(fid3,'%f\n',T1);
fprintf(fid3,'%f\n',T2);
fprintf(fid3,'%f\n',Tp);
fprintf(fid3,'%f\n',Max);
fprintf(fid3,'%f\n',Min);
fprintf(fid3,'%f\n',Mean);
fprintf(fid3,'%f\n',Stdev);
fprintf(fid3,'%f\n',exp_max);
fprintf(fid3,'%f\n',prob_max);



end
end





