%%Coupled
clear all 
clc
close all

lambda=15; %Scaling factor
ro=1.025; % Density of water

filename=[...
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4000b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4001b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4002b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4003b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4004b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4005d.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4006a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4007a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4008a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4009a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\4010a.bin';

'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5000a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5001a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5002a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5003a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5004a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5005a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5006a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5007a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5008a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5009a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\5010a.bin';

'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6000b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6001a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6002e.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6003a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6004d.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6005b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6006a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6007a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6008a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6009a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\6010a.bin';
];
%Periods:
T=[0.731; 0.833; 0.924; 1.007; 1.084; 1.155; 1.222; 1.286; 1.307; 1.367; 1.424;
    0.731; 0.833; 0.924; 1.007; 1.084; 1.155; 1.222; 1.286; 1.307; 1.367; 1.424; 
    0.731; 0.833; 0.924; 1.007; 1.084; 1.155; 1.222; 1.286; 1.307; 1.367; 1.424; 
];
%Distances from origo to wave probe:
x=[0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085;
   0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085; 0.085;
   0.7525; 0.7525; 0.7525; 0.7525; 0.7525; 0.7525; 0.7525; 0.7525; 0.7525; 0.7525; 0.7525; 
    ];

for i=1:size(filename,1)
clc
disp(' ') 
disp('Now running file:: ')
disp(filename(i,:))
disp(' ')
disp(i)

% Read results from file
[a1,a2,Time,Frame,Fx_58,Fy_58,Fz_58,Fx_96,Fy_96,Fz_96,Xpos,Ypos,Zpos,Roll,Pitch,Yaw,Wave]=catman_read(filename(i,:));

%% Correcting for shift b/c of wave probe placement:
g=9.81; %Gravity
omega=2*pi/T(i);
V_p=g/(2*omega); %Phase velocity
time_lag=x(i)/V_p; %Time for wave to travel between wave probe and origo
fz=200; %Sample frequency wave probe
frame_lag=round(time_lag*fz);

%Shift wave 
for j=frame_lag+1:length(Wave)-frame_lag-1
    Wave2(j)=Wave(j-frame_lag); 
end

Wave=Wave2; % Replacing unshifted wave with shifted wave. 

%% Scaling
Time=Time*sqrt(lambda);
Fx_58=ro*lambda^3*Fx_58;
Fy_58=ro*lambda^3*Fy_58;
Fz_58=ro*lambda^3*Fz_58;
Fx_96=ro*lambda^3*Fx_96;
Fy_96=ro*lambda^3*Fy_96;
Fz_96=ro*lambda^3*Fz_96;
Xpos=lambda*Xpos;
Ypos=lambda*Ypos;
Zpos=lambda*Zpos;
Wave=lambda*Wave;

fig = figure;
set(fig,'units','normalized','outerposition',[0.5 0 0.5 1]);

%Plot for visual inspection
subplot(6,2,1); plot(Time, Xpos); title('Xpos')
subplot(6,2,2); plot(Time, Ypos); title('Ypos')
subplot(6,2,3); plot(Time, Zpos); title('Zpos')
subplot(6,2,4); plot(Time, Roll); title('Roll')
subplot(6,2,5); plot(Time, Pitch); title('Pitch')
subplot(6,2,6); plot(Time, Yaw); title('Yaw')
subplot(6,2,7); plot(Time,Fx_58); title('Fx_58')
subplot(6,2,8); plot(Time,Fy_58); title('Fy_58')
subplot(6,2,9); plot(Time,Fz_58); title('Fz_58')
subplot(6,2,10); plot(Time,Fx_96); title('Fx_96')
subplot(6,2,11); plot(Time,Fy_96); title('Fy_96')
subplot(6,2,12); plot(Time,Fz_96); title('Fz_96')

%% Extracting best time periods 
%Find scaled sampling frequency
fi=Time(3)-Time(2);
fc=1/fi; 

finish=0;
while finish==0

disp('Enter start and end time, enter 0 for both for reset')
first(i)=round(fc*input('Enter start time: '));
last(i)=round(fc*input('Enter end time: '));

if first(i)==0; first(i)=1; end
if last(i)==0; last(i)=length(Time); end


% Extracting desired time periods    
Wave_red=Wave(1,first(i):last(i));
Time_red=Time(1,first(i):last(i));
Xpos_red=Xpos(1,first(i):last(i));
Ypos_red=Ypos(1,first(i):last(i));
Zpos_red=Zpos(1,first(i):last(i));
Roll_red=Roll(1,first(i):last(i));
Pitch_red=Pitch(1,first(i):last(i));
Yaw_red=Yaw(1,first(i):last(i));
Fx_58_red=Fx_58(1,first(i):last(i));
Fy_58_red=Fy_58(1,first(i):last(i));
Fz_58_red=Fz_58(1,first(i):last(i));
Fx_96_red=Fx_96(1,first(i):last(i));
Fy_96_red=Fy_96(1,first(i):last(i));
Fz_96_red=Fz_96(1,first(i):last(i));

% New plots
subplot(6,2,1); plot(Time_red, Xpos_red); title('Xpos')
subplot(6,2,2); plot(Time_red, Ypos_red); title('Ypos')
subplot(6,2,3); plot(Time_red, Zpos_red); title('Zpos')
subplot(6,2,4); plot(Time_red, Roll_red); title('Roll')
subplot(6,2,5); plot(Time_red, Pitch_red); title('Pitch')
subplot(6,2,6); plot(Time_red, Yaw_red); title('Yaw')
subplot(6,2,7); plot(Time_red,Fx_58_red); title('Fx_58')
subplot(6,2,8); plot(Time_red,Fy_58_red); title('Fy_58')
subplot(6,2,9); plot(Time_red,Fz_58_red); title('Fz_58')
subplot(6,2,10); plot(Time_red,Fx_96_red); title('Fx_96')
subplot(6,2,11); plot(Time_red,Fy_96_red); title('Fy_96')
subplot(6,2,12); plot(Time_red,Fz_96_red); title('Fz_96')

finish=input('All good? yes=1, no=0 ');
end
close all

%% Calculate statistics 
%Remove bias
Xpos_red=Xpos_red-(mean(Xpos_red));
Ypos_red=Ypos_red-(mean(Ypos_red));
Zpos_red=Zpos_red-(mean(Zpos_red));
Yaw_red=Yaw_red-mean(Yaw_red);
Fx_58_red=Fx_58_red-mean(Fx_58_red);
Fy_58_red=Fy_58_red-mean(Fy_58_red);
Fz_58_red=Fz_58_red-mean(Fz_58_red);
Fx_96_red=Fx_96_red-mean(Fx_96_red);
Fy_96_red=Fy_96_red-mean(Fy_96_red);
Fz_96_red=Fz_96_red-mean(Fz_96_red);



%Calculate and store results into result matrix:
Result(1,i)=min(Xpos_red);
Result(2,i)=min(Ypos_red);
Result(3,i)=min(Zpos_red);
Result(4,i)=min(Roll_red);
Result(5,i)=min(Pitch_red);
Result(6,i)=min(Yaw_red);
Result(7,i)=min(Fx_58_red);
Result(8,i)=min(Fy_58_red);
Result(9,i)=min(Fz_58_red);
Result(10,i)=min(Fx_96_red);
Result(11,i)=min(Fy_96_red);
Result(12,i)=min(Fz_96_red);

Result(13,i)=max(Xpos_red);
Result(14,i)=max(Ypos_red);
Result(15,i)=max(Zpos_red);
Result(16,i)=max(Roll_red);
Result(17,i)=max(Pitch_red);
Result(18,i)=max(Yaw_red);
Result(19,i)=max(Fx_58_red);
Result(20,i)=max(Fy_58_red);
Result(21,i)=max(Fz_58_red);
Result(22,i)=max(Fx_96_red);
Result(23,i)=max(Fy_96_red);
Result(24,i)=max(Fz_96_red);

Result(25,i)=mean(Xpos_red);
Result(26,i)=mean(Ypos_red);
Result(27,i)=mean(Zpos_red);
Result(28,i)=mean(Roll_red);
Result(29,i)=mean(Pitch_red);
Result(30,i)=mean(Yaw_red);
Result(31,i)=mean(Fx_58_red);
Result(32,i)=mean(Fy_58_red);
Result(33,i)=mean(Fz_58_red);
Result(34,i)=mean(Fx_96_red);
Result(35,i)=mean(Fy_96_red);
Result(36,i)=mean(Fz_96_red);

Result(37,i)=std(Xpos_red);
Result(38,i)=std(Ypos_red);
Result(39,i)=std(Zpos_red);
Result(40,i)=std(Roll_red);
Result(41,i)=std(Pitch_red);
Result(42,i)=std(Yaw_red);
Result(43,i)=std(Fx_58_red);
Result(44,i)=std(Fy_58_red);
Result(45,i)=std(Fz_58_red);
Result(46,i)=std(Fx_96_red);
Result(47,i)=std(Fy_96_red);
Result(48,i)=std(Fz_96_red);


%% Filter results

%Calculating FFT of unfiltered
N=size(Wave_red,2)/2;
Wave_mag=abs(fft(Wave_red));
Fx_58_mag=abs(fft(Fx_58_red));
Fy_58_mag=abs(fft(Fy_58_red));
Fz_58_mag=abs(fft(Fz_58_red));
Fx_96_mag=abs(fft(Fx_96_red));
Fy_96_mag=abs(fft(Fy_96_red));
Fz_96_mag=abs(fft(Fz_96_red));
Xpos_mag=abs(fft(Xpos_red));
Ypos_mag=abs(fft(Ypos_red));
Zpos_mag=abs(fft(Zpos_red));
Roll_mag=abs(fft(Roll_red));
Pitch_mag=abs(fft(Pitch_red));
Yaw_mag=abs(fft(Yaw_red));

%Frequencies
num=length(Wave_red);
fs=fc; 
f=(0:1/(num/2-1):1)*fs/2; %Frequencies from 0 to 1 

%Design a band-pass Butterworth filter
Wn1=0.75/(T(i)*sqrt(lambda));
Wn2=1.25/(T(i)*sqrt(lambda));

Wp = [Wn1 Wn2]*2/fc; 
Ws = [Wn1*0.5 Wn2*1.5]*2/fc;
Rp = 3; 
Rs = 4;
[n,Wn] = buttord(Wp,Ws,Rp,Rs);    % Gives mimimum order of filter   
[b3,a3] = butter(n,Wn);           % Butterworth filter design  
    
hv=fvtool(b3,a3); %Plot filter properties
    
%Apply filter
Wavefil=filtfilt(b3,a3,Wave_red);
Fx_58fil=filtfilt(b3,a3,Fx_58_red);
Fy_58fil=filtfilt(b3,a3,Fy_58_red);
Fz_58fil=filtfilt(b3,a3,Fz_58_red);
Fx_96fil=filtfilt(b3,a3,Fx_96_red);
Fy_96fil=filtfilt(b3,a3,Fy_96_red);
Fz_96fil=filtfilt(b3,a3,Fz_96_red);
Xposfil=filtfilt(b3,a3,Xpos_red);
Yposfil=filtfilt(b3,a3,Ypos_red);
Zposfil=filtfilt(b3,a3,Zpos_red);
Rollfil=filtfilt(b3,a3,Roll_red);
Pitchfil=filtfilt(b3,a3,Pitch_red);
Yawfil=filtfilt(b3,a3,Yaw_red);

%Calculate and plot the response magnitude
Wavefil_mag=abs(fft(Wavefil));
Fx_58fil_mag=abs(fft(Fx_58fil));
Fy_58fil_mag=abs(fft(Fy_58fil));
Fz_58fil_mag=abs(fft(Fz_58fil));
Fx_96fil_mag=abs(fft(Fx_96fil));
Fy_96fil_mag=abs(fft(Fy_96fil));
Fz_96fil_mag=abs(fft(Fz_96fil));
Xposfil_mag=abs(fft(Xposfil));
Yposfil_mag=abs(fft(Yposfil));
Zposfil_mag=abs(fft(Zposfil));
Rollfil_mag=abs(fft(Rollfil));
Pitchfil_mag=abs(fft(Pitchfil));
Yawfil_mag=abs(fft(Yawfil));

% Save wavespectrum plot to file
ymax=(max(smooth(Wave_mag(1:length(f))))*1.3);
h=figure;
plot(f,smooth(Wave_mag(1:length(f)))) %Plot unfiltered
hold on
plot(f,smooth(Wavefil_mag(1:length(f))),'r')
legend('Unfiltered','Band-pass filtered')
xlabel('Frequency (Hz)')
ylabel('Magnitude')
axis([0 1 0 ymax])

name = sprintf('Results_coupled/%s', filename(i,47:51));
print(h,'-djpeg',name);
close all
disp('Plot saved to file:')
disp(name)
disp(' ')


%% Calculating transfer functions

% Find max wave amplitude and index of that amplitude, then corresponding
% amplitudes for the different channels. 
[Amp_Wavefil_mag ind]=max(Wavefil_mag(:));
Amp_Fx_58fil_mag=Fx_58fil_mag(ind);
Amp_Fy_58fil_mag=Fy_58fil_mag(ind);
Amp_Fz_58fil_mag=Fz_58fil_mag(ind);
Amp_Fx_96fil_mag=Fx_96fil_mag(ind);
Amp_Fy_96fil_mag=Fy_96fil_mag(ind);
Amp_Fz_96fil_mag=Fz_96fil_mag(ind);
Amp_Xposfil_mag=Xposfil_mag(ind);
Amp_Yposfil_mag=Yposfil_mag(ind);
Amp_Zposfil_mag=Zposfil_mag(ind);
Amp_Rollfil_mag=Rollfil_mag(ind);
Amp_Pitchfil_mag=Pitchfil_mag(ind);
Amp_Yawfil_mag=Yawfil_mag(ind);


%RAO - store all in a matrix. 
Trans(1,i)=Amp_Fx_58fil_mag/Amp_Wavefil_mag;
Trans(2,i)=Amp_Fy_58fil_mag/Amp_Wavefil_mag;
Trans(3,i)=Amp_Fz_58fil_mag/Amp_Wavefil_mag;
Trans(4,i)=Amp_Fx_96fil_mag/Amp_Wavefil_mag;
Trans(5,i)=Amp_Fy_96fil_mag/Amp_Wavefil_mag;
Trans(6,i)=Amp_Fz_96fil_mag/Amp_Wavefil_mag;
Trans(7,i)=Amp_Xposfil_mag/Amp_Wavefil_mag;
Trans(8,i)=Amp_Yposfil_mag/Amp_Wavefil_mag;
Trans(9,i)=Amp_Zposfil_mag/Amp_Wavefil_mag;
Trans(10,i)=Amp_Rollfil_mag/Amp_Wavefil_mag;
Trans(11,i)=Amp_Pitchfil_mag/Amp_Wavefil_mag;
Trans(12,i)=Amp_Yawfil_mag/Amp_Wavefil_mag;

disp(' ')
disp('Analysis of file is now complete')
disp(' ')

end

%% Print all results to file 

fid2=fopen('Stat_Results_coupled.txt','w');
for i=1:size(Result,1)
    
fprintf(fid2, '%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n',Result(i,:));
end
disp('Results are now written to file Results_coupled')

fid3=fopen('Transfer_Results_coupled.txt','w');
for i=1:size(Trans,1)
    
fprintf(fid3, '%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n',Trans(i,:));
end
disp('Results are now written to file Transfer_Results_coupled')



%% Combine calculated transfer functions in plots

%Create time vector
Tfull=T*sqrt(lambda);

%Create array with y-labels
y_label{1}='Surge RAO (m/m)';
y_label{2}='Sway RAO (m/m)'; 
y_label{3}='Heave RAO (m/m)'; 
y_label{4}='Roll RAO (deg/m)';
y_label{5}='Pitch RAO (deg/m)';
y_label{6}='Yaw RAO (deg/m)';
y_label{7}='X-force RAO (kN/m)';
y_label{8}='Y-force RAO (kN/m)';
y_label{9}='Z-force RAO (kN/m)';


% Plot transfer functions 
deg=[0 315 90];
for l=1:3
    if l==1
        fi=1;
        la=11;
    elseif l==2
        fi=12;
        la=22;
    elseif l==3
        fi=23;
        la=33;
    end
    
    
%Motion 
h1=figure;
subplot(3,2,1);      plot(Tfull(fi:la),Trans(7,(fi:la)),':mo');   xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{1}, 'FontSize',8);    
subplot(3,2,2);      plot(Tfull(fi:la),Trans(8,(fi:la)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{2}, 'FontSize',8);   
subplot(3,2,3);      plot(Tfull(fi:la),Trans(9,(fi:la)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{3}, 'FontSize',8);  
subplot(3,2,4);      plot(Tfull(fi:la),Trans(10,(fi:la)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{4}, 'FontSize',8);  
subplot(3,2,5);      plot(Tfull(fi:la),Trans(11,(fi:la)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{5}, 'FontSize',8);  
subplot(3,2,6);      plot(Tfull(fi:la),Trans(12,(fi:la)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{6}, 'FontSize',8); 

set(gcf,'NextPlot','add');
axes;
titlename=sprintf('Motion RAO for coupled condition, wave heading %d degrees ',deg(l));

h = title(titlename,'FontSize',12);
set(gca,'Visible','off');
set(h,'Visible','on');
name = sprintf('Transferplots_coupled/%d_deg_motion',deg(l));
print(h1,'-djpeg',name);


% Force
h2=figure;
subplot(3,1,1);  plot(Tfull(fi:la),Trans(1,fi:la)./1000,':mo','Color','b'); hold on;   plot(Tfull(fi:la),Trans(4,fi:la)./1000,':mo','Color','r'); legend('Fx-58','Fx-96');   xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{7}, 'FontSize',8);   
subplot(3,1,2);  plot(Tfull(fi:la),Trans(2,fi:la)./1000,':mo','Color','b');hold on;    plot(Tfull(fi:la),Trans(5,fi:la)./1000,':mo','Color','r'); legend('Fy-58','Fy-96');   xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{8}, 'FontSize',8);   
subplot(3,1,3);  plot(Tfull(fi:la),Trans(3,fi:la)./1000,':mo','Color','b');hold on;    plot(Tfull(fi:la),Trans(6,fi:la)./1000,':mo','Color','r'); legend('Fz-58','Fz-96');   xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{9}, 'FontSize',8);   

set(gcf,'NextPlot','add');
axes;
titlename2=sprintf('Force RAO for coupled condition, wave heading %d degrees ',deg(l));

h = title(titlename2, 'FontSize',12);
set(gca,'Visible','off');
set(h,'Visible','on');
name = sprintf('Transferplots_coupled/%d_deg_force',deg(l));
print(h2,'-djpeg',name);
close all
end 










