%%Uncoupled
clear all 
clc
close all

lambda=15; %Scaling factor
ro=1.025; %Density of water

filename=[...
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1000b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1001a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1002a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1003a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1004a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1005b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1006b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1007b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1008b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1009b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1010a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\1011a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3000a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3001a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3002a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3003a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3004a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3005a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3006c.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3007b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3008b.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3009c.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3010c.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\3011b.bin';
];

% Wave periods:
T=[0.731; 0.833; 0.924; 1.007; 1.084; 1.155; 1.222; 1.286; 1.347; 1.405; 1.461; 1.515;
    0.731; 0.833; 0.924; 1.007; 1.084; 1.155; 1.222; 1.286; 1.347; 1.405; 1.461; 1.515;
    ];
%Distances from origo to wave probe:
x=[3.68; 3.68; 3.68; 3.68; 3.68; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 
   3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775; 3.775;
   ];

for i=1:size(filename,1)
clc
clear Wave2
disp(' ') 
disp('Now running file:: ')
disp(filename(i,:))
disp(' ')
disp(i)

% Read results from file
[a1,a2,Time,Frame,Fx_58,Fy_58,Fz_58,Fx_96,Fy_96,Fz_96,Xpos,Ypos,Zpos,Roll,Pitch,Yaw,Wave]=catman_read(filename(i,:));



%% Correcting for shift b/c of wave probe placement:
g=9.81; %Gravity
omega=2*pi/T(i);
V_p=g/omega; %Phase velocity
time_lag=x(i)/V_p; %Time for wave to travel between wave probe and origo
fz=200; %Sample frequency wave probe
frame_lag=round(time_lag*fz);

%Shift wave
for j=frame_lag+1:length(Wave)-frame_lag-1
    Wave2(j)=Wave(j-frame_lag); 
end

Wave=Wave2; %Replacing unshifted wave with shifted wave. 


%% Scaling 
%Scaling the results
Time=Time*sqrt(lambda);
Xpos=lambda*Xpos;
Ypos=lambda*Ypos;
Zpos=lambda*Zpos;
Wave=lambda*Wave;

fig = figure;
set(fig,'units','normalized','outerposition',[0.5 0 0.5 1]);


%Plot for visual inspection
subplot(6,1,1); plot(Time, Xpos); title('Xpos')
subplot(6,1,2); plot(Time, Ypos); title('Ypos')
subplot(6,1,3); plot(Time, Zpos); title('Zpos')
subplot(6,1,4); plot(Time, Roll); title('Roll')
subplot(6,1,5); plot(Time, Pitch); title('Pitch')
subplot(6,1,6); plot(Time, Yaw); title('Yaw')

%% Extracting best time periods 

%Find scaled sampling frequency
fi=Time(3)-Time(2);
fc=1/fi; 

finish=0;
while finish==0

disp('Enter start and end time, enter 0 for both for reset')
first(i)=round(fc*input('Enter start time: '));
last(i)=round(fc*input('Enter end time: '));

if first(i)==0; first(i)=1; end
if last(i)==0; last(i)=length(Time); end


%Extracting desired time periods 
Wave_red=Wave(1,first(i):last(i));
Time_red=Time(1,first(i):last(i));
Xpos_red=Xpos(1,first(i):last(i));
Ypos_red=Ypos(1,first(i):last(i));
Zpos_red=Zpos(1,first(i):last(i));
Roll_red=Roll(1,first(i):last(i));
Pitch_red=Pitch(1,first(i):last(i));
Yaw_red=Yaw(1,first(i):last(i));

%New plots to check
subplot(6,1,1); plot(Time_red, Xpos_red); title('Xpos')
subplot(6,1,2); plot(Time_red, Ypos_red); title('Ypos')
subplot(6,1,3); plot(Time_red, Zpos_red); title('Zpos')
subplot(6,1,4); plot(Time_red, Roll_red); title('Roll')
subplot(6,1,5); plot(Time_red, Pitch_red); title('Pitch')
subplot(6,1,6); plot(Time_red, Yaw_red); title('Yaw')

finish=input('Time periods OK? yes=1, no=0 ');

end
close all


%% Calculate statistics
%Remove bias
Xpos_red=Xpos_red-(mean(Xpos_red));
Ypos_red=Ypos_red-(mean(Ypos_red));
Zpos_red=Zpos_red-(mean(Zpos_red));
Yaw_red=Yaw_red-mean(Yaw_red);

%Calculate statistics and store results into result matrix:
Result(1,i)=min(Xpos_red);
Result(2,i)=min(Ypos_red);
Result(3,i)=min(Zpos_red);
Result(4,i)=min(Roll_red);
Result(5,i)=min(Pitch_red);
Result(6,i)=min(Yaw_red);
Result(7,i)=max(Xpos_red);
Result(8,i)=max(Ypos_red);
Result(9,i)=max(Zpos_red);
Result(10,i)=max(Roll_red);
Result(11,i)=max(Pitch_red);
Result(12,i)=max(Yaw_red);

Result(13,i)=mean(Xpos_red);
Result(14,i)=mean(Ypos_red);
Result(15,i)=mean(Zpos_red);
Result(16,i)=mean(Roll_red);
Result(17,i)=mean(Pitch_red);
Result(18,i)=mean(Yaw_red);

Result(19,i)=std(Xpos_red);
Result(20,i)=std(Ypos_red);
Result(21,i)=std(Zpos_red);
Result(22,i)=std(Roll_red);
Result(23,i)=std(Pitch_red);
Result(24,i)=std(Yaw_red);


%% Filter results

%Calculating FFT of unfiltered
N=size(Wave_red,2)/2;
Wave_mag=abs(fft(Wave_red));
Xpos_mag=abs(fft(Xpos_red));
Ypos_mag=abs(fft(Ypos_red));
Zpos_mag=abs(fft(Zpos_red));
Roll_mag=abs(fft(Roll_red));
Pitch_mag=abs(fft(Pitch_red));
Yaw_mag=abs(fft(Yaw_red));

%Frequencies
num=length(Wave_red);
fs=fc; 
f=(0:1/(num/2-1):1)*fs/2; %Frequencies from 0 to 1 

%Design a band-pass Butterworth filter
Wn1=0.75/(T(i)*sqrt(lambda))
Wn2=1.25/(T(i)*sqrt(lambda))

Wp = [Wn1 Wn2]*2/fc; 
Ws = [Wn1*0.5 Wn2*1.5]*2/fc;
Rp = 3; 
Rs = 4;
[n,Wn] = buttord(Wp,Ws,Rp,Rs);    % Gives mimimum order of filter   
[b3,a3] = butter(n,Wn);           % Butterworth filter design  
    
hv=fvtool(b3,a3); %Plot filter properties
    
%Apply filter
Wavefil=filtfilt(b3,a3,Wave_red);
Xposfil=filtfilt(b3,a3,Xpos_red);
Yposfil=filtfilt(b3,a3,Ypos_red);
Zposfil=filtfilt(b3,a3,Zpos_red);
Rollfil=filtfilt(b3,a3,Roll_red);
Pitchfil=filtfilt(b3,a3,Pitch_red);
Yawfil=filtfilt(b3,a3,Yaw_red);


%Calculate and plot the response magnitude
Wavefil_mag=abs(fft(Wavefil));
Xposfil_mag=abs(fft(Xposfil));
Yposfil_mag=abs(fft(Yposfil));
Zposfil_mag=abs(fft(Zposfil));
Rollfil_mag=abs(fft(Rollfil));
Pitchfil_mag=abs(fft(Pitchfil));
Yawfil_mag=abs(fft(Yawfil));

ymax=(max(smooth(Wave_mag(1:length(f))))*1.3);

close all

% Save wavespectrum plot to file
h=figure;
plot(f,smooth(Wave_mag(1:length(f)))) %Plot unfiltered
hold on
plot(f,smooth(Wavefil_mag(1:length(f))),'r')
legend('Unfiltered','Band-pass filtered')
xlabel('Frequency (Hz)')
ylabel('Magnitude')
axis([0 1 0 ymax])

name = sprintf('Results_uncoupled/%s', filename(i,47:51));
print(h,'-djpeg',name);
close all
disp('Plot saved to file:')
disp(name)
disp(' ')


%% Calculating transfer functions

%Find max wave amplitude and index of that amplitude, then corresponding
%amplitudes for the different channels. 
[Amp_Wavefil_mag ind]=max(Wavefil_mag(:));
Amp_Xposfil_mag=Xposfil_mag(ind);
Amp_Yposfil_mag=Yposfil_mag(ind);
Amp_Zposfil_mag=Zposfil_mag(ind);
Amp_Rollfil_mag=Rollfil_mag(ind);
Amp_Pitchfil_mag=Pitchfil_mag(ind);
Amp_Yawfil_mag=Yawfil_mag(ind);


%RAO - store all in a matrix. 
Trans(1,i)=Amp_Xposfil_mag/Amp_Wavefil_mag;
Trans(2,i)=Amp_Yposfil_mag/Amp_Wavefil_mag;
Trans(3,i)=Amp_Zposfil_mag/Amp_Wavefil_mag;
Trans(4,i)=Amp_Rollfil_mag/Amp_Wavefil_mag;
Trans(5,i)=Amp_Pitchfil_mag/Amp_Wavefil_mag;
Trans(6,i)=Amp_Yawfil_mag/Amp_Wavefil_mag;

disp(' ')
disp('Analysis of file is now complete')

end


%% Print all results to file 

fid2=fopen('Stat_Results_uncoupled.txt','w');
for i=1:size(Result,1)
fprintf(fid2, '%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n',Result(i,:));
end
disp('Results are now written to file Results_uncoupled')


fid3=fopen('Transfer_Results_uncoupled.txt','w');
for i=1:size(Trans,1)
    
fprintf(fid3, '%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n',Trans(i,:));
end
disp('Results are now written to file Transfer_Results_uncoupled')



%% Combine calculated transfer functions in plots

%Create time vector
Tfull=T*sqrt(lambda);

%Create array with y-labels
y_label{1}='Surge RAO (m/m)';
y_label{2}='Sway RAO (m/m)'; 
y_label{3}='Heave RAO (m/m)'; 
y_label{4}='Roll RAO (deg/m)';
y_label{5}='Pitch RAO (deg/m)';
y_label{6}='Yaw RAO (deg/m)';


% Plot transfer functions for wave heading 90 degrees
hh=figure;
subplot(3,2,1);      plot(Tfull(1:12),Trans(1,(1:12)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{1}, 'FontSize',8);    
subplot(3,2,2);      plot(Tfull(1:12),Trans(2,(1:12)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{2}, 'FontSize',8);   
subplot(3,2,3);      plot(Tfull(1:12),Trans(3,(1:12)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{3}, 'FontSize',8);  
subplot(3,2,4);      plot(Tfull(1:12),Trans(4,(1:12)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{4}, 'FontSize',8);  
subplot(3,2,5);      plot(Tfull(1:12),Trans(5,(1:12)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{5}, 'FontSize',8);  
subplot(3,2,6);      plot(Tfull(1:12),Trans(6,(1:12)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{6}, 'FontSize',8); 

set(gcf,'NextPlot','add');
axes;
h1 = title('Motion RAO for uncoupled condition, wave heading 90 degrees ', 'FontSize',12);
set(gca,'Visible','off');
set(h1,'Visible','on');
name = sprintf('Transferplots_uncoupled/90deg');
print(hh,'-djpeg',name);

% Plot transfer functions fro wave heading 0 degrees
h3=figure;
a=subplot(3,2,1);    plot(Tfull(13:end),Trans(1,(13:end)),':mo');   xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{1}, 'FontSize',8);    
subplot(3,2,2);      plot(Tfull(13:end),Trans(2,(13:end)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{2}, 'FontSize',8);   
subplot(3,2,3);      plot(Tfull(13:end),Trans(3,(13:end)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{3}, 'FontSize',8);  
subplot(3,2,4);      plot(Tfull(13:end),Trans(4,(13:end)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{4}, 'FontSize',8);  
subplot(3,2,5);      plot(Tfull(13:end),Trans(5,(13:end)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{5}, 'FontSize',8);  
subplot(3,2,6);      plot(Tfull(13:end),Trans(6,(13:end)),':mo');     xlabel('Wave period (s)', 'FontSize',8);      ylabel(y_label{6}, 'FontSize',8); 


set(gcf,'NextPlot','add');
axes;
h2 = title('Motion RAO for uncoupled condition, wave heading 0 degrees ', 'FontSize',12);
set(gca,'Visible','off');
set(h2,'Visible','on');
name = sprintf('Transferplots_uncoupled/0deg');
print(h3,'-djpeg',name);

close all








