
close all
clear all
lambda=15;
ro=1.025

filename=[...
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\8000a.bin';
'C:\Users\Anna\Dropbox\M14\Modelltest\Res\Data\8001a.bin';
]
for i=1:size(filename,1)
clc

disp(' ')
disp('This is file:')
disp(filename(i,:))

% Read results from file
[a1,a2,Time,Frame,Fx_58,Fy_58,Fz_58,Fx_96,Fy_96,Fz_96,Xpos,Ypos,Zpos,Roll,Pitch,Yaw,Wave]=catman_read(filename(i,:));


%% Scaling 
Time=Time*sqrt(lambda);
Fx_58=ro*lambda^3*Fx_58;
Fy_58=ro*lambda^3*Fy_58;
Fz_58=ro*lambda^3*Fz_58;
Fx_96=ro*lambda^3*Fx_96;
Fy_96=ro*lambda^3*Fy_96;
Fz_96=ro*lambda^3*Fz_96;
Xpos=lambda*Xpos;
Ypos=lambda*Ypos;
Zpos=lambda*Zpos;
Wave=lambda*Wave;

%Removing bias
Xpos=Xpos-(mean(Xpos));
Ypos=Ypos-(mean(Ypos));
Zpos=Zpos-(mean(Zpos));
Yaw=Yaw-mean(Yaw);


fig = figure;
set(fig,'units','normalized','outerposition',[0.5 0 0.5 1]);

%Plot for visual inspection
subplot(6,2,1); plot(Time, Xpos); title('Xpos')
subplot(6,2,2); plot(Time, Ypos); title('Ypos')
subplot(6,2,3); plot(Time, Zpos); title('Zpos')
subplot(6,2,4); plot(Time, Roll); title('Roll')
subplot(6,2,5); plot(Time, Pitch); title('Pitch')
subplot(6,2,6); plot(Time, Yaw); title('Yaw')
subplot(6,2,7); plot(Time,Fx_58); title('Fx_58')
subplot(6,2,8); plot(Time,Fy_58); title('Fy_58')
subplot(6,2,9); plot(Time,Fz_58); title('Fz_58')
subplot(6,2,10); plot(Time,Fx_96); title('Fx_96')
subplot(6,2,11); plot(Time,Fy_96); title('Fy_96')
subplot(6,2,12); plot(Time,Fz_96); title('Fz_96')

%% Extracting best time periods 

%Find scaled sampling frequency
fi=Time(3)-Time(2);
fc=1/fi; 

finish=0;

while finish==0

disp('Enter start and end time, enter 0 for both for reset')
first(i)=round(fc*input('Enter start time: '));
last(i)=round(fc*input('Enter end time: '));
load framenumbers_checkt.mat
if first(i)==0; first(i)=1; end
if last(i)==0; last(i)=length(Time); end



%Extracting desired time periods
Wave_red=Wave(1,first(i):last(i));
Time_red=Time(1,first(i):last(i));
Xpos_red=Xpos(1,first(i):last(i));
Ypos_red=Ypos(1,first(i):last(i));
Zpos_red=Zpos(1,first(i):last(i));
Roll_red=Roll(1,first(i):last(i));
Pitch_red=Pitch(1,first(i):last(i));
Yaw_red=Yaw(1,first(i):last(i));
Fx_58_red=Fx_58(1,first(i):last(i));
Fy_58_red=Fy_58(1,first(i):last(i));
Fz_58_red=Fz_58(1,first(i):last(i));
Fx_96_red=Fx_96(1,first(i):last(i));
Fy_96_red=Fy_96(1,first(i):last(i));
Fz_96_red=Fz_96(1,first(i):last(i));


%New plots
subplot(6,2,1); plot(Time_red, Xpos_red); title('Xpos')
subplot(6,2,2); plot(Time_red, Ypos_red); title('Ypos')
subplot(6,2,3); plot(Time_red, Zpos_red); title('Zpos')
subplot(6,2,4); plot(Time_red, Roll_red); title('Roll')
subplot(6,2,5); plot(Time_red, Pitch_red); title('Pitch')
subplot(6,2,6); plot(Time_red, Yaw_red); title('Yaw')
subplot(6,2,7); plot(Time_red,Fx_58_red); title('Fx_58')
subplot(6,2,8); plot(Time_red,Fy_58_red); title('Fy_58')
subplot(6,2,9); plot(Time_red,Fz_58_red); title('Fz_58')
subplot(6,2,10); plot(Time_red,Fx_96_red); title('Fx_96')
subplot(6,2,11); plot(Time_red,Fy_96_red); title('Fy_96')
subplot(6,2,12); plot(Time_red,Fz_96_red); title('Fz_96')

finish=input('All good? yes=1, no=0 ');
end




%% STORING STATISTICS
%Store results into result matrix:

Result(1,i)=mean(Fx_58_red);
Result(2,i)=mean(Fy_58_red);
Result(3,i)=mean(Fz_58_red);
Result(4,i)=mean(Fx_96_red);
Result(5,i)=mean(Fy_96_red);
Result(6,i)=mean(Fz_96_red);

%% Print all results to file %%

fid2=fopen('Results_checkt.txt','w');
for i=1:size(Result,1)
    
fprintf(fid2, '%f %f\n',Result(i,:));
end
disp('Results are now written to file Results_checkt')
end 




