% clear all 
close all
clc 

load Results/Platformandship/platformandship_RAOS.mat
load Results/Platformandship/platformandship_Freqs.mat



T=fr;

%Cut off time series to reduce computing time:
tmin=find(T>0.01);
tmin=tmin(1);
tmax=find(T>0.3);
tmax=tmax(1);


%Colors
cmap=hsv(5);


%% Surge
figure (1);
hold on

for k=1:3
%      
         plot(T,smooth(RAOstruct(k).Surge,10),'Color',cmap(k,:))
         
end

legend('Setup 1', 'Setup 2', 'Setup 3')

title('Surge transfer functions')
xlabel('Wave frequency (Hz)')
ylabel('RAO (m/m)')
 xlim([0.01 0.3])
 ylim([0 20])

print(1,'-djpeg','Results/Platformandship/RAO_comparison/SurgeRAO');

%%

%Sway
figure(2)


hold on
for k=1:3
    
    plot(T(tmin:tmax),smooth(RAOstruct(k).Sway(tmin:tmax),10),'Color',cmap(k,:))
  
end
legend('Setup 1', 'Setup 2', 'Setup 3')
xlim([0 0.2]) 
title('Sway transfer functions')
xlabel('Wave frequency (Hz)')
ylabel('RAO (m/m)')
xlim([0.01 0.3])
ylim([0 45])

print(2,'-djpeg','Results/Platformandship/RAO_comparison/SwayRAO');

%% Heave


figure(3)
for k=1:3
plot(T(tmin:tmax),smooth(RAOstruct(k).Heave(tmin:tmax),10),'Color',cmap(k,:))
hold on 

end
legend('Setup 1', 'Setup 2', 'Setup 3')

title('Heave transfer functions')
xlabel('Wave period (s)')
ylabel('RAO (m/m)')
xlim([0.01 0.3])
ylim([0 40])

%Save plot to file. 
print(3,'-djpeg','Results/Platformandship/RAO_comparison/HeaveRAO');
%%

%Roll
figure(4)
hold on
for k=1:3
    
  plot(T(tmin:tmax),smooth(RAOstruct(k).Roll(tmin:tmax),10),'Color',cmap(k,:))
  
end
legend('Setup 1', 'Setup 2', 'Setup 3')

title('Roll transfer functions')
xlabel('Wave period (s)')
ylabel('RAO (deg/m)')
xlim([0.01 0.3])
ylim([0 400])

print(4,'-djpeg','Results/Platformandship/RAO_comparison/RollRAO');


%%

%Pitch
figure(5)
hold on
for k=1:3
    
   plot(T(tmin:tmax),smooth(RAOstruct(k).Pitch(tmin:tmax),10),'Color',cmap(k,:))
end
legend('Setup 1', 'Setup 2', 'Setup 3')

title('Pitch transfer functions')
xlabel('Wave period (s)')
ylabel('RAO (deg/m)')
xlim([0.01 0.3])
ylim([0 20])


print(5,'-djpeg','Results/Platformandship/RAO_comparison/PitchRAO');

%% Yaw
figure(6)
hold on
for k=1:3
    
    plot(T(tmin:tmax),smooth(RAOstruct(k).Yaw(tmin:tmax),10),'Color',cmap(k,:))
  
end
legend('Setup 1', 'Setup 2', 'Setup 3')

title('Yaw transfer functions')
xlabel('Wave period (s)')
ylabel('RAO (deg/m)')
xlim([0.01 0.3])
ylim([0 650])


print(6,'-djpeg','Results/Platformandship/RAO_comparison/YawRAO');

%% Xforce
figure(7)
hold on
for k=1:3

    plot(T(tmin:tmax),smooth(RAOstruct(k).Fx(tmin:tmax)/1000,10),'Color',cmap(k,:))
  
end
legend('Setup 1', 'Setup 2', 'Setup 3')

title('X-force transfer functions')
xlabel('Wave period (s)')
ylabel('RAO (kN/m)')
xlim([0.01 0.3])
% ylim([0 3.5e1])

print(7,'-djpeg','Results/Platformandship/RAO_comparison/FxRAO');

%% Fy
figure(8)
hold on
for k=1:3
 
   plot(T(tmin:tmax),smooth(RAOstruct(k).Fy(tmin:tmax)/1000,10),'Color',cmap(k,:))
  
end
legend('Setup 1', 'Setup 2', 'Setup 3')

title('Y-force transfer functions')
xlabel('Wave period (s)')
ylabel('RAO (kN/m)')
xlim([0.01 0.3])
% ylim([0 500])

print(8,'-djpeg','Results/Platformandship/RAO_comparison/FyRAO');


%%


%Fz
figure(9)
hold on
for k=1:3

   plot(T(tmin:tmax),smooth(RAOstruct(k).Fz(tmin:tmax)/1000,10),'Color',cmap(k,:))
  
end
legend('Setup 1', 'Setup 2', 'Setup 3')

title('Z-force transfer functions')
xlabel('Wave period (s)')
ylabel('RAO (kN/m)')
xlim([0.01 0.3])
% ylim([0 100])


print(9,'-djpeg','Results/Platformandship/RAO_comparison/FzRAO');

